controllers/SiteController.php
<?php

namespace app\controllers;
use yii\data\SqlDataProvider;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\Ciclista;
use app\models\Lleva;
use app\models\Puerto;
use app\models\Etapa;
use yii\data\ActiveDataProvider;
use app\models\Equipo;


class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }
    
    /*
     * Creado esta accion
     */
    
    public function actionCrud(){
        return $this->render('gestion');
    }


     public function actionConsulta1a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            
            'query'=> Ciclista::find()->join('inner join', 'etapa','ciclista.dorsal=etapa.dorsal')->distinct()->select("nombre, edad")
                ,
            'pagination'=>[
                'pageSize'=>0,
                ]
        ]);
                
           return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['nombre', 'edad'],
            "titulo"=>"Consulta 1",
            "enunciado"=>"Nombre y edad de los ciclistas que han ganado etapas.",
            "sql"=>"SELECT DISTINCT c.nombre, c.edad FROM etapa e INNER JOIN ciclista c ON c.dorsal=e.dorsal",
        ]);
    }
    
     public function actionConsulta1(){
            // mediante DAO
        $numero=Yii::$app
                ->db->createCommand("SELECT COUNT(*) FROM (SELECT DISTINCT c.nombre, c.edad FROM etapa e INNER JOIN ciclista c ON c.dorsal=e.dorsal) c1" )
                ->queryScalar(); // cuenta los registros que hay en la consulta y lo guarda $numero
        
        $dataProvider= new SqlDataProvider([
            'sql'=> "SELECT DISTINCT c.nombre, c.edad FROM etapa e INNER JOIN ciclista c ON c.dorsal=e.dorsal" ,
            'totalCount' => $numero, // se lo pasamos de arriba
            'pagination'=>[
                'pageSize'=>0,
                ],
        ]);
        
            return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['nombre', 'edad'],
            "titulo"=>"Consulta 1",
            "enunciado"=>"Nombre y edad de los ciclistas que han ganado etapas.",
            "sql"=>"SELECT DISTINCT c.nombre, c.edad FROM etapa e INNER JOIN ciclista c ON c.dorsal=e.dorsal",
        ]);


     }

    
     public function actionConsulta2a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            
            'query'=> Ciclista::find()->innerjoin( 'puerto','ciclista.dorsal=puerto.dorsal')->distinct()->select("nombre, edad")
                 ,
            'pagination'=>[
                'pageSize'=>0,
                ]
        ]);
                
        // $a=Ciclista::find()->innerJoinWith( 'puertos',true,'inner join')->all();
        // var_dump($a[0]->puertos); // innerJoinWith utiliza los modelos que ya est´n relacionados 
           return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['nombre', 'edad'],
            "titulo"=>"Consulta 2",
            "enunciado"=>"Nombre y edad de los ciclistas que han ganado puertos.",
            "sql"=>"SELECT DISTINCT c.nombre, c.edad FROM puerto p INNER JOIN ciclista c ON c.dorsal=p.dorsal",
        ]);
    }
    
     public function actionConsulta2(){
            // mediante DAO
        $numero=Yii::$app
                ->db->createCommand("SELECT COUNT(*) FROM (SELECT DISTINCT c.nombre, c.edad FROM puerto p INNER JOIN ciclista c ON c.dorsal=p.dorsal) c1" )
                ->queryScalar(); // cuenta los registros que hay en la consulta y lo guarda $numero
        
        $dataProvider= new SqlDataProvider([
            'sql'=> "SELECT DISTINCT c.nombre, c.edad FROM etapa e INNER JOIN ciclista c ON c.dorsal=e.dorsal" ,
            'totalCount' => $numero, // se lo pasamos de arriba
            'pagination'=>[
                'pageSize'=>0,
                ],
        ]);
        
            return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['nombre', 'edad'],
            "titulo"=>"Consulta 2",
            "enunciado"=>"Nombre y edad de los ciclistas que han ganado puertos.",
            "sql"=>"SELECT DISTINCT c.nombre, c.edad FROM puerto p INNER JOIN ciclista c ON c.dorsal=p.dorsal",
        ]);


     }
     
     
          public function actionConsulta3a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            
            'query'=> Ciclista::find()->innerjoin( 'etapa','ciclista.dorsal=etapa.dorsal')->innerJoin('puerto','ciclista.dorsal=puerto.dorsal')->distinct()->select("nombre, edad")
                 ,
            'pagination'=>[
                'pageSize'=>0,
                ]
        ]);
                
        // $a=Ciclista::find()->innerJoinWith( 'puertos',true,'inner join')->all();
        // var_dump($a[0]->puertos); // innerJoinWith utiliza los modelos que ya est´n relacionados 
           return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['nombre', 'edad'],
            "titulo"=>"Consulta 3",
            "enunciado"=>"Nombre y edad de los ciclistas que han ganado etapas y puertos.",
            "sql"=>"SELECT DISTINCT c.nombre, c.edad FROM (etapa e INNER JOIN ciclista c ON c.dorsal=e.dorsal) INNER JOIN puerto p ON c.dorsal=p.dorsal",
        ]);
    }
    
     public function actionConsulta3(){
            // mediante DAO
        $numero=Yii::$app
                ->db->createCommand("SELECT COUNT(*) FROM (SELECT DISTINCT c.nombre, c.edad FROM (etapa e INNER JOIN ciclista c ON c.dorsal=e.dorsal) INNER JOIN puerto p ON c.dorsal=p.dorsal) c1" )
                ->queryScalar(); // cuenta los registros que hay en la consulta y lo guarda $numero
        
        $dataProvider= new SqlDataProvider([
            'sql'=> "SELECT DISTINCT c.nombre, c.edad FROM (etapa e INNER JOIN ciclista c ON c.dorsal=e.dorsal) INNER JOIN puerto p ON c.dorsal=p.dorsal" ,
            'totalCount' => $numero, // se lo pasamos de arriba
            'pagination'=>[
                'pageSize'=>0,
                ],
        ]);
        
            return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['nombre', 'edad'],
            "titulo"=>"Consulta 3",
            "enunciado"=>"Nombre y edad de los ciclistas que han ganado etapas y puertos.",
            "sql"=>"SELECT DISTINCT c.nombre, c.edad FROM (etapa e INNER JOIN ciclista c ON c.dorsal=e.dorsal) INNER JOIN puerto p ON c.dorsal=p.dorsal",
        ]);


     }
    
    
    public function actionConsulta4a(){
        
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Equipo::find()->innerJoinWith('ciclistas',true)->innerJoin('etapa','etapa.dorsal=ciclista.dorsal')->distinct()->select("director")
                         ,
            'pagination'=>[
                'pageSize'=>0,
                ]
        ]);
                
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['director'],
            "titulo"=>"Consulta 4",
            "enunciado"=>"Listar el director de los equipos que tengan ciclistas que hayan ganado alguna etapa.",
            "sql"=>"SELECT DISTINCT equipo.director FROM equipo INNER JOIN (ciclista INNER JOIN etapa ON ciclista.dorsal=etapa.dorsal) ON equipo.nomequipo=ciclista.nomequipo",
        ]);
    }
    
     public function actionConsulta4(){
            // mediante DAO
        
        
        $dataProvider= new SqlDataProvider([
            'sql'=> "SELECT DISTINCT equipo.director FROM equipo INNER JOIN (ciclista INNER JOIN etapa ON ciclista.dorsal=etapa.dorsal) ON equipo.nomequipo=ciclista.nomequipo" ,
        
            'pagination'=>[
                'pageSize'=>0,
                ],
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['director'],
            "titulo"=>"Consulta 4",
            "enunciado"=>"Listar el director de los equipos que tengan ciclistas que hayan ganado alguna etapa.",
            "sql"=>"SELECT DISTINCT equipo.director FROM equipo INNER JOIN (ciclista INNER JOIN etapa ON ciclista.dorsal=etapa.dorsal) ON equipo.nomequipo=ciclista.nomequipo",
        ]);
    }
    
    public function actionConsulta5a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Ciclista::find()->innerJoinWith ('llevas',true)->distinct()->select("ciclista.dorsal,nombre")
                ,
            'pagination'=>[
                'pageSize'=>10,
                ]
        ]);
                

views/site/_listar.php
        <tr>
            <td><h3><?= $model->num ?>  </h3></td>
            
        </tr>
        

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/gestion.php
<?php

use yii\helpers\Html;

echo Html::a('Ciclistas',
        ['ciclista/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Etapas',
        ['etapa/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Equipos',
        ['equipo/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Lleva',
        ['lleva/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Maillot',
        ['maillot/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Puerto',
        ['puerto/index'],
        ['class' => 'btn btn-primary btn-large']
        );



?>

views/site/index.php
<?php
use yii\bootstrap\Html;
/* @var $this yii\web\View */

$this->title = 'My Yii Application';
?>

<div class="site-index">

    <div class="jumbotron">
        <h1>consultas de seleccion 4</h1>
Application
        <p class="lead">Modulo 3 Unidad 2</p>
    </div>

    <div class="body-content">

        <div class="row">
            
             <!-- primera consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 1</h3>
                      <p>Nombre y edad de los ciclistas que han ganado etapas</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta1a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta1'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
             
              <!-- segunda consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 2</h3>
                      <p>Listar el dorsal de los ciclistas que son de Banesto o cuya edad esta entre 25 y 32.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta2a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta2'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
              <!-- tercera consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 3</h3>
                      <p>Nombre y edad de los ciclistas que han ganado etapas y puertos.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta3a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta3'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
              <!-- cuarta consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 4</h3>
                      <p>Listar el director de los equipos que tengan ciclistas que hayan ganado alguna etapa.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta4a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta4'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
              <!-- quinta consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 5</h3>
                      <p>Dorsal y nombre de los ciclistas que hayan llevado algín maillot.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta5a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta5'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
              <!-- sexta consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 6</h3>
                      <p>Dorsal y nombre de los ciclistas que hayan llevado algín maillot amarillo.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta6a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta6'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
              <!-- septima consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 7</h3>
                      <p>Dorsal de los ciclistas que hayan llevado algún maillot que han ganado etapas.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta7a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta7'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
              
              <!-- octava consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 8</h3>
                      <p>Indicar el numetapa de las etapas que tngan puertos.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta8a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta8'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
              <!-- novena consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 9</h3>
                      <p>Indicar los km de las etapas que hayan ganado ciclistas del Banesto y que tengan puertos.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta9a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta9'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
              <!-- decima consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 10</h3>
                      <p>Listar el número de ciclists que hayan ganado alguna etapa con puerto.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta10a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta10'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
                            <!-- undecima  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 11</h3>
                      <p>Indicar el nombre de los puertos que hayan sido ganados por los ciclistas de Banesto.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta11a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta11'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
                            
                            <!-- duodecima  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 12</h3>
                      <p>Listar el número de etapas que tengan puerto que hayan sido ganados por ciclistas de Banesto con mas de 200 Km.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta12a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta12'],['class' => 'btn btn-default btn-large']);?>
                          <?= Html::a('ListView',['site/consulta12b'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>

              
        </div>

    </div>
</div>

views/site/listView.php
<div>
    <h1>Listar el número de etapas que tengan puerto que hayan sido ganados por ciclistas de Banesto con mas de 200 Km.</h1>
    
</div>

<?php
use yii\widgets\ListView;
?>
<table border="5">
    <thead>
        <tr>
            <th>Dorsal</th>
        </tr>
    </thead>
      <tbody>
<?php
echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_listar',
]);
?>
  
    </tbody>
</table>

views/site/resultado.php
<?php
use yii\grid\GridView;

?>


 <div class="jumbotron">
        <h1><?= $titulo?></h1>
        <p class="lead"><?=$enunciado?></p>
            <div class="well"> 
            <?= $sql?>
            </div>
    </div>
    
    
    <?= GridView::widget([
        'dataProvider' => $resultados,
        'columns' => $campos,
                
    ]);?>